-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function Attack05:StartActivity()
	print("START! -- Attack05:StartActivity()!");

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	 --self.ConfigName = "current.dat";
	self.ConfigName = "current.dat";
	self.ModuleName = "UnmappedLands.rte";
	
	self.Config = CF_ReadConfigFile(self.ModuleName , self.ConfigName);
	CF_InitFactions();
	CF_InitMission(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------

	self.EnemyLZ = SceneMan.Scene:GetArea("EnemyLZ");
	self.Base = SceneMan.Scene:GetArea("Base");
	self.BrainRoom = SceneMan.Scene:GetArea("BrainRoom");
	self.UploadArea = SceneMan.Scene:GetArea("UploadArea");
	self.UploadTerminal = SceneMan.Scene:GetArea("UploadTerminal");
	self.DistributionPoint = SceneMan.Scene:GetArea("EnemyLZ");--SceneMan.Scene:GetArea("DistributionPoint");
	--[[
	self.Posts = {};
	for i = 1 , 5 do
		self.Posts[i] = SceneMan.Scene:GetArea("Post"..i);
	end

	self.IsPostEmpty = {};
	for i = 1 , 5 do
		self.IsPostEmpty[i] = true;
	end
	--]]
	
	self.BasePosts = {};
	for i = 1 , 5 do
		self.BasePosts[i] = SceneMan.Scene:GetArea("BasePost"..i);
	end
	
	self.IsBasePostEmpty = {};
	for i = 1 , 5 do
		self.IsBasePostEmpty[i] = true;
	end
	
	self.IsBaseEmpty = true;
	

	self.ChunksComplete = 0;
	self.TotalChunks = 100;
	self.ChunkInterval = 700;
	
	self.ScreenActivated = false;
	x = 0
	y = 0
	self.braindead = {};
	self.AssignedBrains = {};
	
	for player = 0, self.PlayerCount - 1 do
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CF_SpawnBrain(CF_PlayerTeam , nil , CF_PlayerFaction , Actor.AIMODE_SENTRY);
			-- brain.Pos = Vector(192 , 264); -- Debug
			brain.Pos = Vector(9300,850); -- Gameplay
			brain.AIMode = Actor.AIMODE_SENTRY;
			self.AssignedBrains[player] = brain;

            MovableMan:AddActor(brain);
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
			self:SwitchToActor(brain, player, CF_PlayerTeam);
        end
    end

	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReplaceAddedActors(self.Config);
	CF_ArrangeEliteActors(self.Config);
	-- end of generic part	
	---------------------------------------------------------------------
	
	--self:SpawnBazookaActors();

    self.FightPhase = { GETCODE = 0 , UPLOAD = 1 , EVACUATE = 2};
    self.CurrentFightPhase = self.FightPhase.GETCODE;
	
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();

	self.DropshipSpawnInterval = 20000;
	self.DropshipSpawnTimer = Timer();
	self.DropshipSpawnTimer:Reset();
	for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
	end	

	-- Debug
	--[[self.Screen = CreateAEmitter("Att01 Download Screen");
	self.Screen.Pos = Vector(192 , 264);
	self.Screen:EnableEmission(true);
	MovableMan:AddParticle(self.Screen); --]]--
	
	
	--[[for actor in MovableMan.AddedActors do
		if actor.Team == CF_CPUTeam then
			actor:GibThis();
		end
	end
	
	--]]
	
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function Attack05:PauseActivity(pause)
    print("PAUSE! -- Attack05:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function Attack05:EndActivity()
    print("END! -- Attack05:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack05:SpawnBazookaActors()
	for i = 1 , #self.Posts do
		local newactor, price;

		-- Create unarmed infantry unit
		newactor , price = CF_SpawnInfantry(false , false , false , false , CF_CPUTeam , nil , CF_CPUFaction , Actor.AIMODE_SENTRY);
		newactor.Pos = self.Posts[i]:GetCenterPoint();
	
		if CF_CPUFaction == CF_Factions.COALITION then
			newactor:AddInventoryItem(CreateHDFirearm("Homing Missile Launcher" , "Coalition.rte"));
		elseif CF_CPUFaction == CF_Factions.DUMMY then
			newactor:AddInventoryItem(CreateHDFirearm("Dummy APR Launcher" , self.ModuleName));
		elseif CF_CPUFaction == CF_Factions.RONIN then
			newactor:AddInventoryItem(CreateHDFirearm("Bazooka" , "Ronin.rte"));
		end
		
		MovableMan:AddActor(newactor);
    end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack05:DistributeReinforcements()
	-- Assign falling troops to specific firing points
	for actor in MovableMan.Actors do
		if actor.Team == CF_CPUTeam and actor.AIMode == Actor.AIMODE_SENTRY then
			if self.DistributionPoint:IsInside(actor.Pos) then
				local isassigned;
				isassigned = false;
				for i = 1 , #self.IsBasePostEmpty do
					if self.IsBasePostEmpty[i] then
						actor.AIMode = Actor.AIMODE_GOTO;
						actor:ClearAIWaypoints();
						actor:AddAISceneWaypoint(self.BasePosts[i]:GetCenterPoint());
						
						isassigned = true;
						break;
					end -- if
				end -- for i
				
				-- If all points in selected zone are taken, assign to brain hunt
				-- to avoid crowds of sentry troops
				if not isassigned then
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end
			end -- if 
		end -- if
	end
end
-----------------------------------------------------------------------------------------
-- Update base defence stats to make dispatch decisions later
-----------------------------------------------------------------------------------------
function Attack05:UpdateBaseDefenceStats()
	-- Reset all current states, they are refilled here
	-- Zones are considered non-empty if we have non-expired troops sent to this zone
	--[[
	for i = 1 , #self.IsPostEmpty do
		self.IsPostEmpty[i] = true;
	end
	--]]
	for i = 1 , #self.IsBasePostEmpty do
		self.IsBasePostEmpty[i] = true;
	end
	
	self.IsBaseEmpty = true;
	
	for actor in MovableMan.Actors do
		-- Check for empty firing points
		if actor.Team == CF_CPUTeam  then
			if actor:IsInGroup("Brains") then
				self.AIcommander = actor
			end
		--[[
			for i = 1 , #self.Posts do
				if self.Posts[i]:IsInside(actor.Pos) then
					self.IsPostEmpty[i] = false;
				end -- if
			end -- for
		--]]
			for i = 1 , #self.BasePosts do
				if self.BasePosts[i]:IsInside(actor.Pos) then
					self.IsBasePostEmpty[i] = false;
				end -- if
			end -- for
		end -- if

		if actor.Team == CF_PlayerTeam  then
			if self.Base:IsInside(actor.Pos) then
				self.IsBaseEmpty = false;
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function Attack05:SpawnDropship()
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if MovableMan:GetMOIDCount() < CF_MOIDLimit - 20 then
			local ship = nil;
			local actor = nil;
			local price = 0;
			local totalprice = 0;
			local p;
			local landpos;
			local spawnaa; -- Flags if we need to spawn Anti Aircraft troops
			local spawnteam;
			if self.CurrentFightPhase ~= self.FightPhase.EVACUATE then
				spawnteam = CF_CPUTeam
			else
				spawnteam =math.random(-1,1)
			end
			spawnaa = false;
			
			-- Select landing zone
			--landpos = Vector(self.EnemyLZ:GetCenterPoint().X , -10);
			landpos = Vector(self.EnemyLZ:GetRandomPoint().X, -10);
			-- Add AA troopers if AI base is empty or with 15% probability if it is not
			--[[
			if self.IsBaseEmpty or math.random() < 0.15 then
				for i = 1, #self.IsPostEmpty do
					if self.IsPostEmpty[i] then
						landpos = Vector(self.Posts[i]:GetCenterPoint().X , -10);
						spawnaa = true;
						break;
					end
				end
			end
			--]]
			ship , price = CF_SpawnDropship(spawnteam , landpos , CF_CPUFaction);
			totalprice = totalprice + price;
			
			if spawnaa then
				actor , price = CF_SpawnInfantry(false , false , false , false , spawnteam , nil , CF_CPUFaction , Actor.AIMODE_SENTRY);
			
				if CF_CPUFaction == CF_Factions.COALITION then
					actor:AddInventoryItem(CreateHDFirearm("Homing Missile Launcher" , "Coalition.rte"));
				elseif CF_CPUFaction == CF_Factions.DUMMY then
					actor:AddInventoryItem(CreateHDFirearm("Dummy APR Launcher" , self.ModuleName));
				elseif CF_CPUFaction == CF_Factions.RONIN then
					actor:AddInventoryItem(CreateHDFirearm("Bazooka" , "Ronin.rte"));
				end

				ship:AddInventoryItem(actor);				
			else
				local aimode;
				
				aimode = Actor.AIMODE_SENTRY;
				
				if self.CurrentFightPhase ~= self.FightPhase.GETCODE then
					aimode = Actor.AIMODE_BRAINHUNT;
				end
			
				-- Spawn armor or regular troopers depending on turn number to increase difficulty
				if math.random(100) < 10 then
					-- Give single dreadnought as dummy armor or two assalut troopers with shields
					-- to any other faction
					actor , price = CF_SpawnArmor(spawnteam , nil , CF_CPUFaction , aimode);
					totalprice = totalprice + price;
						
					ship:AddInventoryItem(actor);
					
				else
					actor , price = CF_SpawnRandomInfantry(spawnteam , nil , CF_CPUFaction , aimode);
					totalprice = totalprice + price;

					ship:AddInventoryItem(actor);
				end
			end

			MovableMan:AddActor(ship);
		end
		self.DropshipSpawnTimer:Reset();
	end
end
-----------------------------------------------------------------------------------------
-- Phase GETCODE
-----------------------------------------------------------------------------------------
function Attack05:PhaseGETCODE()
	self:UpdateBaseDefenceStats();
	self:DistributeReinforcements();
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self:GetPlayerBrain(player)) then
			if not self.GenericTimer:IsPastSimMS(5000) then
				self:AddObjectivePoint("Protect Commander", self:GetPlayerBrain(player).AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	if not MovableMan:IsActor(self.AIcommander) then
		self:AdvanceToUpload();
	else
		self:AddObjectivePoint("Kill to disable upload security", self.AIcommander.AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWDOWN);
	end
end

-----------------------------------------------------------------------------------------
function Attack05:AdvanceToUpload()
	self.DropshipSpawnInterval = self.DropshipSpawnInterval * 0.7;
	FrameMan:SetScreenText("Security disabled, upload that virus!", 0, 500, 10000, true);
	for actor in MovableMan.Actors do
		if actor.Team == CF_CPUTeam and actor.AIMode == Actor.AIMODE_SENTRY and not self.UploadArea:IsInside(actor.Pos) then
			actor.AIMode = Actor.AIMODE_BRAINHUNT;
		end
	end
	self.CurrentFightPhase = self.FightPhase.UPLOAD;
end
-----------------------------------------------------------------------------------------
-- Phase 
-----------------------------------------------------------------------------------------
function Attack05:PhaseUpload()
	local isinside = false;

	-- Show boot completion mark
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self:GetPlayerBrain(player)) then
			if self.UploadTerminal:IsInside(self:GetPlayerBrain(player).Pos) then
				isinside = true;
			
				if not self.ScreenActivated then
					self.Screen = CreateAEmitter("Att01 Download Screen");
					self.Screen.Pos = Vector(2988 , 516);
					self.Screen:EnableEmission(true);
					MovableMan:AddParticle(self.Screen);
					
					self.ScreenActivated = true;
				end
			end
		end -- for
		
		-- Check boot status
		if not isinside then
			-- Reset all completion signs if we're not inside the terminal zone
			self:AddObjectivePoint("Upload Control Virus", self.UploadTerminal:GetCenterPoint() + Vector(0 , - 25), CF_PlayerTeam, GameActivity.ARROWDOWN);
			if MovableMan:IsParticle(self.Screen) then
				MovableMan:RemoveParticle(self.Screen);
				self.Screen = nil;
			end
			
			self.ChunksComplete = 0;
			self.ScreenActivated = false;
			self.GenericTimer:Reset();
		else
			self:AddObjectivePoint(string.format("Uploading: %d%%", self.ChunksComplete / self.TotalChunks * 100), self.UploadTerminal:GetCenterPoint() + Vector(0 , - 25), CF_PlayerTeam, GameActivity.ARROWDOWN);

			if self.GenericTimer:IsPastSimMS(self.ChunkInterval) then
				self.ChunksComplete = self.ChunksComplete + 1;

				if self.ChunksComplete == self.TotalChunks then
					--print ("Data downloaded");
					MovableMan:RemoveParticle(self.Screen);
					self.Screen = nil;
					self.Screen = CreateAEmitter("Att01 Download Screen Done");
					self.Screen.Pos = Vector(2988 , 516);
					self.Screen:EnableEmission(true);
					MovableMan:AddParticle(self.Screen);
					self:AdvanceToEvacuate();
				end

				self.GenericTimer:Reset();
			end
		end -- if - else
	end
end
-----------------------------------------------------------------------------------------
-- 
-----------------------------------------------------------------------------------------
function Attack05:AdvanceToEvacuate()
	self.CurrentFightPhase = self.FightPhase.EVACUATE;
	self.DropshipSpawnInterval = self.DropshipSpawnInterval * 0.7;
	for actor in MovableMan.Actors do
		if actor.Team == CF_CPUTeam and actor.ClassName ~= "ADoor" then
			local pos = actor.Pos
			local aimode = actor.AIMode
			actor.Lifetime = 1
			CF_SpawnRandomInfantry(math.random(-1,1), pos, CF_CPUFaction, aimode)
		end
	end
end
-----------------------------------------------------------------------------------------
-- Phase GETCODE
-----------------------------------------------------------------------------------------
function Attack05:PhaseEvacuate()
	for player = 0, self.PlayerCount - 1 do
		if MovableMan:IsActor(self:GetPlayerBrain(player)) then
			self:AddObjectivePoint("EVACUATE!", self:GetPlayerBrain(player).AboveHUDPos, CF_PlayerTeam, GameActivity.ARROWUP);
		end
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function Attack05:UpdateActivity()
   	self:ClearObjectivePoints();
	--[[
	if not self.GenericTimer:IsPastSimMS(1500) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Disable upload security, upload control virus!", player, 500, 10000, true);
		end
	end
	--]]
	self:SpawnDropship();

	if self.CurrentFightPhase == self.FightPhase.GETCODE then
		self:PhaseGETCODE();
	elseif self.CurrentFightPhase == self.FightPhase.UPLOAD then
		self:PhaseUpload();
	elseif self.CurrentFightPhase == self.FightPhase.EVACUATE then
		self:PhaseEvacuate();
	end	
	
	---------------------------------------------------------------------
	-- Mission framework generic part. Must present in every mission!
	CF_ReturnOnMissionEnd();
	CF_CheckForeignTroops();
	-- end of generic part
	---------------------------------------------------------------------
	
	self:DoBrainSelection();
	
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function Attack05:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					self.braindead[player] = true;
					
					if not MovableMan:GetClosestBrainActor(team) then
						if CF_Activity.ActivityState ~= Activity.OVER then
							---------------------------------------------------------------------
							-- Mission framework generic part. Must present in every mission!
							CF_CommitDefeat(self.Config , self.ModuleName , self.ConfigName);
							-- end of generic part
							---------------------------------------------------------------------
							self.WinnerTeam = self:OtherTeam(team);
							ActivityMan:EndActivity();
						end
					end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end --if
end
-----------------------------------------------------------------------------------------
-- Enter orbit, check winning conditions
-----------------------------------------------------------------------------------------
function Attack05:CraftEnteredOrbit()
	print (CF_BrainPresets[CF_PlayerFaction]);
	if self.OrbitedCraft:HasObject(CF_BrainPresets[CF_PlayerFaction]) then
		if CF_Activity.ActivityState ~= Activity.OVER then
			if self.CurrentFightPhase == self.FightPhase.EVACUATE then
				---------------------------------------------------------------------
				-- Mission framework generic part. Must present in every mission!
				CF_CommitVictory(self.Config , self.ModuleName , self.ConfigName);
				-- end of generic part
				---------------------------------------------------------------------
				self.WinnerTeam = CF_PlayerTeam;
			else
				---------------------------------------------------------------------
				-- Mission framework generic part. Must present in every mission!
				CF_CommitRetreat(self.Config , self.ModuleName , self.ConfigName);
				-- end of generic part
				---------------------------------------------------------------------
				self.WinnerTeam = CF_CPUTeam;
			end
			ActivityMan:EndActivity();
		end
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































